from datetime import datetime
from typing import Callable, List, Optional

import numpy as np
from pymemri.data.schema import Item, Tweet


class ClusterEntry(Item):
    relevance: Optional[float] = None
    data: List[Tweet] = []


class Cluster(Item):
    isUnassigned: Optional[bool] = None
    category: Optional[str] = None
    clusterDescription: Optional[str] = None
    isRead: Optional[bool] = None
    readLater: Optional[bool] = None
    entry: List[ClusterEntry] = []


class TwitterTopicModel(Item):
    startDate: Optional[datetime] = None
    cluster: List[Cluster] = []
